import 'package:flutter_test/flutter_test.dart';

import 'package:tiger_graph/tiger_graph.dart';

void main() async {
  GraphClient graphClient = await GraphClient.getInstance('1sk0p2btufa5mqtlv0d8pm2oph82t6ob', 'MyGraph', 'fraud-det.i.tgcloud.us:9000');

  test('get vertex valid input', () async {
    Map<String, String> vertex = {'vType': 'UserID', 'vId': '999'};
    Map result = await graphClient.getVertex(vertex);
    print(result);
    expect(result['error'], false);
  });

  test('get edges valid input', () async{
    print(await graphClient.getEdge({'vType': 'UserID', 'vId': '876'}, edgeType: 'User_Event'));
  });

  test('delete edges valid input', () async{
    print(await graphClient.deleteEdge({'vType': 'Servers', 'vId': '64'}, override: 'DELETE'));
  });

  test('get vertext invalid input paramters', () async{

    Map<String, String> vertex = {'vType': 'UserI', 'vId': '999'};
    graphClient.getVertex(vertex).catchError((
    ){
      expect(true, true);
    });

  });

  test('delete vertex', () async{
    await graphClient.deleteVertex({'vType' : 'UserID', 'vId' : '999'});
  });

  test('create vertex with batch', () async {
    final writeBatch = graphClient.createWriteBatch();

    Map vertex = {'vType': 'UserID', 'vId': '876', 'attrs': {}};
    Map toVertex = {'vType': 'Event', 'vId': '9990', 'attrs': {'Start_Date': '2019-8-17', 'Event_Type': 'Login',
                                                                'End_Date': '2019-8-18', 'Return_Code': 0, 'Endpoint': ""}};
    writeBatch.upsertVertex(vertex);
    writeBatch.upsertVertex(toVertex);
    writeBatch.upsertEdge({'vType': 'UserID', 'vId': '876'}, {'vType': 'Event', 'vId': '9990'}, 'User_Event', {});
    await writeBatch.commit();
  });
  
  test("call query no args", () async{
    print(await graphClient.callQuery('FirewallBypassDetection', {}));
  });
  
  test("call query with args", () async {
    print(await graphClient.callQuery('SuspiciousUsers', {'k': 10}));
  });

}

